1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 if [ $MSGLEVEL -le 3 ]; then
47 if [ $MSGLEVEL -le 4 ]; then
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
59 echo "${CDONE}DONE${CNORMAL}" >&2;
64 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
65 if [ -f .
/aptconfig.conf
]; then
66 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
67 elif [ -f ..
/aptconfig.conf
]; then
68 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
70 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
73 aptconfig
() { runapt apt
-config $
*; }
74 aptcache
() { runapt apt
-cache $
*; }
75 aptget
() { runapt apt
-get $
*; }
76 aptftparchive
() { runapt apt
-ftparchive $
*; }
77 aptkey
() { runapt apt
-key $
*; }
79 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
82 if [ -f .
/aptconfig.conf
]; then
83 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
84 elif [ -f ..
/aptconfig.conf
]; then
85 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
87 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
92 TMPWORKINGDIRECTORY
=$(mktemp -d)
93 local TESTDIR
=$(readlink -f $(dirname $0))
94 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
95 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
96 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
97 local OLDWORKINGDIRECTORY
=$(pwd)
98 CURRENTTRAP
="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
99 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
100 cd $TMPWORKINGDIRECTORY
101 mkdir rootdir aptarchive keys
103 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
104 mkdir -p var
/cache var
/lib var
/log
105 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
106 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
107 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
108 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
110 touch var/lib/dpkg/status
112 touch var/lib/dpkg/available
114 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
116 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
117 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
118 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
120 local SOURCESSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
121 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
122 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
124 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
125 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
126 echo "Dir
\"${TMPWORKINGDIRECTORY}/rootdir
\";" > aptconfig.conf
127 echo "Dir
::state
::status
\"${TMPWORKINGDIRECTORY}/rootdir
/var
/lib
/dpkg
/status
\";" >> aptconfig.conf
128 echo "Debug
::NoLocking
\"true
\";" >> aptconfig.conf
129 echo "APT
::Get
::Show
-User-Simulation-Note \"false
\";" >> aptconfig.conf
130 echo "Dir
::Bin
::Methods
\"${BUILDDIRECTORY}/methods
\";" >> aptconfig.conf
131 echo "Dir
::Bin
::dpkg
\"fakeroot
\";" >> aptconfig.conf
132 echo "DPKG
::options
:: \"dpkg
\";" >> aptconfig.conf
133 echo "DPKG
::options
:: \"--root=${TMPWORKINGDIRECTORY}/rootdir
\";" >> aptconfig.conf
134 echo "DPKG
::options
:: \"--force-not-root\";" >> aptconfig.conf
135 echo "DPKG
::options
:: \"--force-bad-path\";" >> aptconfig.conf
136 echo "DPKG
::options
:: \"--log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log
\";" >> aptconfig.conf
141 configarchitecture() {
142 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
143 echo "APT
::Architecture
\"$1\";" > $CONFFILE
145 while [ -n "$1" ]; do
146 echo "APT
::Architectures
:: \"$1\";" >> $CONFFILE
151 setupsimplenativepackage() {
155 local RELEASE="${4:-unstable}"
156 local DEPENDENCIES="$5"
157 local DESCRIPTION="$6"
158 local SECTION="${7:-others}"
160 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
163 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
165 local BUILDDIR=incoming/${NAME}-${VERSION}
166 mkdir -p ${BUILDDIR}/debian/source
168 echo "* most suckless software product ever
" > FEATURES
169 test -e debian/copyright || echo "Copyleft by Joe Sixpack
$(date +%Y)" > debian/copyright
170 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency
=low
174 -- Joe Sixpack
<joe@example.org
> $(date -R)" > debian/changelog
175 test -e debian/control || echo "Source
: $NAME
178 Maintainer
: Joe Sixpack
<joe@example.org
>
179 Build
-Depends: debhelper
(>= 7)
180 Standards
-Version: 3.9.1
183 Architecture
: $ARCH" > debian/control
184 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
185 if [ -z "$DESCRIPTION" ]; then
186 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
187 If you
find such a package installed on your system
,
188 YOU did something horribly wrong
! They are autogenerated
189 und used only by testcases
for APT and surf no other propose…
" >> debian/control
191 echo "Description
: $DESCRIPTION" >> debian/control
193 test -e debian/compat || echo "7" > debian/compat
194 test -e debian/source/format || echo "3.0 (native
)" > debian/source/format
195 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
199 buildsimplenativepackage() {
203 local RELEASE="${4:-unstable}"
204 local DEPENDENCIES="$5"
205 local DESCRIPTION="$6"
206 local SECTION="${7:-others}"
208 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
211 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
213 setupsimplenativepackage "$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
214 buildpackage "incoming
/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
215 rm -rf "incoming
/${NAME}-${VERSION}"
222 msgninfo "Build package
$(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}…
"
224 if [ "$ARCH" = "all
" ]; then
225 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
227 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
228 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
229 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
232 echo "pool
/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
235 echo "pool
/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
241 if [ -d incoming ]; then
242 buildaptarchivefromincoming $*
244 buildaptarchivefromfiles $*
248 createaptftparchiveconfig() {
249 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb
$#\
1#' | tr '\n' ' ')"
250 if [ -z "$ARCHS" ]; then
251 # the pool is empty, so we will operate on faked packages - let us use the configured archs
252 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
255 ArchiveDir "' >> ftparchive.conf
256 echo -n $(readlink -f .) >> ftparchive.conf
258 CacheDir "' >> ftparchive.conf
259 echo -n $(readlink -f ..) >> ftparchive.conf
261 FileListDir "' >> ftparchive.conf
262 echo -n $(readlink -f pool/) >> ftparchive.conf
266 Packages::Compress ". gzip bzip2 lzma";
267 Sources::Compress ". gzip bzip2 lzma";
268 Contents::Compress ". gzip bzip2 lzma";
272 SrcDirectory "pool/";
278 Label "apttestcases";
280 Description "repository with dummy packages";
281 Architectures "' >> ftparchive.conf
282 echo -n "$ARCHS" >> ftparchive.conf
286 };' >> ftparchive.conf
287 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
288 echo -n 'tree "dists/' >> ftparchive.conf
289 echo -n "$DIST" >> ftparchive.conf
291 Architectures "' >> ftparchive.conf
292 echo -n "$ARCHS" >> ftparchive.conf
294 FileList "' >> ftparchive.conf
295 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
297 SourceFileList "' >> ftparchive.conf
298 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
300 Sections "' >> ftparchive.conf
301 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
303 };' >> ftparchive.conf
307 buildaptftparchivedirectorystructure
() {
308 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
309 for DIST
in $DISTS; do
310 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
311 for SECTION
in $SECTIONS; do
312 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
313 for ARCH
in $ARCHS; do
314 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
316 mkdir -p dists
/${DIST}/${SECTION}/source
317 mkdir -p dists
/${DIST}/${SECTION}/i18n
327 local DEPENDENCIES
="$5"
329 if [ "$ARCHS" = "all" ]; then
330 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
332 for BUILDARCH
in $ARCHS; do
333 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
334 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
335 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
336 local FILE
="${PPATH}/Packages"
340 Installed-Size: 23356
341 Maintainer: Joe Sixpack <joe@example.org>
343 Version: $VERSION" >> $FILE
344 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
345 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
346 If you find such a package installed on your system,
347 YOU did something horribly wrong! They are autogenerated
348 und used only by testcases for APT and surf no other propose…
353 buildaptarchivefromincoming
() {
354 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
356 [ -e pool
] || ln -s ..
/incoming pool
357 [ -e ftparchive.conf
] || createaptftparchiveconfig
358 [ -e dists
] || buildaptftparchivedirectorystructure
359 msgninfo
"\tGenerate Packages, Sources and Contents files… "
360 aptftparchive
-qq generate ftparchive.conf
366 buildaptarchivefromfiles
() {
367 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
368 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
369 msgninfo
"\t${line} file… "
370 cat ${line} | gzip > ${line}.gz
371 cat ${line} | bzip2 > ${line}.bz2
372 cat ${line} | lzma
> ${line}.lzma
378 generatereleasefiles
() {
379 msgninfo
"\tGenerate Release files… "
380 if [ -e aptarchive
/dists
]; then
381 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
382 local CODENAME
="$(echo "$dir" | cut -d'/' -f 4)"
383 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
384 if [ "$CODENAME" = "experimental" ]; then
386 NotAutomatic: yes' $dir/Release
390 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
395 setupdistsaptarchive
() {
396 local APTARCHIVE
=$(readlink -f ./aptarchive)
397 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
398 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
399 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
400 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
401 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
402 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
403 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
408 setupflataptarchive
() {
409 local APTARCHIVE
=$(readlink -f ./aptarchive)
410 if [ -f ${APTARCHIVE}/Packages
]; then
411 msgninfo
"\tadd deb sources.list line… "
412 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
415 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
417 if [ -f ${APTARCHIVE}/Sources
]; then
418 msgninfo
"\tadd deb-src sources.list line… "
419 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
422 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
428 if [ -e aptarchive
/dists
]; then
434 msgninfo
"\tSync APT's cache with the archive… "
440 local SIGNER
="${1:-Joe Sixpack}"
441 msgninfo
"\tSign archive with $SIGNER key… "
443 for KEY
in $(find keys/ -name '*.sec'); do
444 SECKEYS
="$SECKEYS --secret-keyring $KEY"
447 for KEY
in $(find keys/ -name '*.pub'); do
448 PUBKEYS
="$PUBKEYS --keyring $KEY"
450 for RELEASE
in $(find aptarchive/ -name Release); do
451 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
456 changetowebserver
() {
457 if which weborf
> /dev
/null
; then
458 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
459 CURRENTTRAP
="kill $!; $CURRENTTRAP"
460 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
461 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
462 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
463 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
471 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
472 if [ -n "$DIFFTEXT" ]; then
484 msgtest
"Test for correctness of file" "$FILE"
486 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
488 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
493 local COMPAREFILE
=$(mktemp)
494 echo "$1" > $COMPAREFILE
496 msgtest
"Test for equality of" "$*"
497 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
502 local COMPAREFILE1
=$(mktemp)
503 local COMPAREFILE2
=$(mktemp)
504 local COMPAREAGAINST
=$(mktemp)
505 echo "$1" > $COMPAREFILE1
506 echo "$2" > $COMPAREFILE2
508 msgtest
"Test for equality OR of" "$*"
509 $
* 2>&1 1> $COMPAREAGAINST
510 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
511 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
512 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
513 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
515 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
519 local VIRTUAL
="N: Can't select versions from package '$1' as it purely virtual"
522 while [ -n "$1" ]; do
524 N: Can't select versions from package '$1' as it purely virtual"
525 PACKAGE
="${PACKAGE} $1"
528 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
530 N: No packages found"
531 local COMPAREFILE
=$(mktemp)
532 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
533 eval `apt-config shell ARCH APT::Architecture`
534 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
535 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
540 msgtest
"Test for non-existent packages" "apt-cache show $*"
541 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
542 if [ -n "$SHOWPKG" ]; then
551 testdpkginstalled
() {
552 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
553 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
554 if [ "$PKGS" != 0 ]; then
556 dpkg
-l $
* | grep '^[a-z]'
563 testdpkgnoninstalled
() {
564 msgtest
"Test for correctly non-installed package(s) with" "dpkg -l $*"
565 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
566 if [ "$PKGS" != 0 ]; then
568 dpkg
-l $
* | grep '^[a-z]'